/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2003-2004 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */


/*
 *	offset.inc ( offset.h) ɂ
 *
 *	  offset.inc ͍\̗̂̓vf\̂̐擪牽oCgڂ
 *	݂邩ƂƂ, ̃rbgtB[h擪
 *	oCg̉rbgڂɑ݂邩, Ƃ
 *	AZut@Cɗ^邽߂ɑ݂Ă.
 *
 *	  offset.inc t@C̒g, PȂV{`t@Cł.
 *	V{ƂĂ`V{̖̂ɂ̓p^[,
 *	傫Ď3ނɕނł.
 *
 *	<\̖>_<vf>	() TCB_sp, TCB_pc, TCB_enatex Ȃ
 *	<\̖>_<vf>_bit	() TCB_enatex_bit Ȃ
 *	<\̖>_<vf>_mask () TCB_enatex_mask Ȃ
 *
 *	()
 *		TCB_texptn		.equ	14
 *		TCB_sp			.equ	20
 *		TCB_pc			.equ	24
 *		TCB_enatex		.equ	13
 *		TCB_enatex_bit		.equ	 6
 *		TCB_enatex_mask		.equ	0040H
 *
 *	  Ԃ͂߂͓̗vf\̂̐擪牽oCgɂ邩
 *	ƂƂlɂ郉x̖.
 *	  Ԗڂ͓̃rbgtB[h̃rbg, ʂ琔
 *	rbgڂɂ邩ƂƂlɂ郉x̖. 
 *	0n܂鐔lŕ\. łʂ̃rbg͑0rbgł.
 *	  OԖڂ͐قǂ <\̖>_<vf>_bit Ƃ֘A邪,
 *	̃rbgtB[h̃rbg̃}XNl̖.
 *	_bit  *_mask ̒l̊Ԃɂ͎̊֌W.
 *		(*_mask) == (1 << *_bit)
 * *	() TCB_enatex_bit  6 ̎, TCB_enatex_mask  40H
 *
 *	  Ȃ݂M32Cˑ̎ł, rbg̃`FbNȂǂ
 *	rbg߃AhbVOgpĂ̂ *_mask Ƃx
 *	gpĂȂ.
 */

/*
 *	offset.inc ̍(M32C^[Qbgˑ)
 *
 *	  GNU CRpCpĂ^[QbgˑɂĂ,
 *	J[l̃gbvfBNg̉ɂ util ƂfBNg
 *	 genoffset Ƃ perl XNvgpӂĂ̂,
 *	Ɏ蓮 offset.h 쐬Kv͂Ȃ.
 *	  genoffset  GNU Jz肵č쐬Ă̂,
 *	AZu^߂␶K̈قȂ鑼
 *	CRpCɂ͂̂܂ܓKpłȂ\.
 *	  , łWindows  genoffset pӂ,
 *	ɋL, Ƃ offset.inc 쐬Ă炤Ƃ
 *	. ȉɂ̕@. Ȃ, ̕@M32C̊J
 *	߃ZbgɈˑĂ邽, ̃^[QbggpĂꍇ
 *	̂܂ܓKpłȂ.
 *
 *  1.	makeoffset.c Ƃt@CCRpCgp
 *	AZut@C makeoffset.a30 𐶐.
 *	RpCIvV̓J[lR[hɗ^̂Ɠ
 *	̂^. 
 *	lTXc[ TM gpĂꍇ, vWFNgGfB^
 *	菇r[ makeoffset.a30 I, ENbNj[
 *	rhI邱ƂŐł.
 *	̓R}hvvgŃCNt@CƓfBNg
 *	ړ, "make -f CNt@C makeoffset.a30" 
 *	sĂľʂ. (CNt@CTMgp
 *	̂Ɠt@Cw\)
 *
 *  2.	قǂ 1. ̍Ƃœꂽ, makeoffset.a30 t@C
 *	"! BEGIN XXXX"  ł͂܂ "! END" ŏIĂ镔T.
 *
 *	4ӏ, ꂼꏭقȂ̂ŏɐ.
 *	(ȉ, ł̓AZut@C̃Rgs͏Ȃ)
 *
 * (1)	\̂̐擪烁oւ̃ItZbg
 *
 *	! BEGIN TCB_texptn
 *		bset	00H,0000000eH
 *	! END
 *
 *	L"! BEGIN"̌̕offset.incŒ`V{ƂȂ.
 *	̃V{̒l, sbset߂̑2Iyh̒lł
 *	0000000eHɑ. ꂪ\̂̐擪texptn܂ł
 *	ItZbglƂȂ. Ă̏ꍇ, offset.inc ɂ
 *	TCB_texptn	.equ	14
 *	ƂsLq.
 *
 * (2)	\̂̃o\̂, ̒̃oɑ΂ItZbg
 *
 *	TCB_sp ɂĂقړl, sp TCB\̂̒ڂ
 *	ołȂTCB\̂̃ołTSKCTXB\̂̃o
 *	_قȂ. ł`V{ƂĂ
 *	TCB_sp ̂悤ɕ\. AZut@Cł
 *
 *	! BEGIN TCB_sp
 *		mov.l	00000014H,A0
 *		extz	[A0],R0
 *		bset	0,R0L
 *		mov.l	#00000014H,A0
 *		mov.b	R0L,[[A0]]
 *	! END *
 *
 *	̂悤ɂȂ,14H(=20) ߂lȂ̂offset.inc ɂ͎̂悤
 *	Lq.
 *
 *	TCB_sp	.equ	20
 *
 * (3)	o֐ւ̃|C^łꍇ
 *
 *	 TCB_pc ̏ꍇ.
 *
 *	! BEGIN TCB_pc
 *		mov.l	#00000018H,A0
 *		jsri.a	[A0]
 *	! END
 *
 *	pc  sp Ɠ, TCB\̂̒ڂ̃oł͂Ȃ
 *	TCB_pc ƕ\Ă. ͊֐̃AhXi[ϐȂ̂,
 *	(((TCB *)0)->tskctxb.pc)();
 *	ƂĊ֐Ăяô悤ɋLqƏL̂悤ȃAZu
 *	R[ho͂. V{`ۂ̃V{͍܂ł
 *	, TCB_pc Ƃ. 
 *	߂l͍\̂֐|C^܂ł̃ItZbgł, mov.l
 *	߂̌ʂ 	00000018H(=24) ƂȂ.
 *	, offset.inc ɂ͎̂悤ɋLq.
 *
 *	TCB_pc	.equ	24
 *
 * (4)	\̂̃orbgtB[hł̃rbgʒum肽ꍇ
 *
 *	! BEGIN TCB_enatex
 *		bset	6,0000000cH+1
 *	! END
 *
 *	܂łƓl, BEGIN ̌̕V{Ƃ.
 *	łTCB_enatex̒l͍\̂̐擪rbgtB[h܂ރo
 *	Cg܂ł̃ItZbg, M32C̃rbg߃AhbVO͎wł
 *	rbgʒu07̊ԂɎ܂悤ɃANZXAhXɓK
 *	̂ cH+1(=13) ƂȂĂ. ܂, rbgtB[h
 *	̍ŉʃrbg̃rbgʒu 6ƂȂ.
 *	ȏ莟̂悤ɏƂł.
 *
 *		TCB_enatex	.equ	13
 *		TCB_enatex_bit	.equ	 6
 *		TCB_enatex_mask	.equ	40H
 */

#include "kernel_impl.h"
#include "task.h"
#include "sil.h"

const TCB	____BEGIN_OFF_TCB_tstat = {
		{ NULL, NULL }, NULL , 1, 0,
		0, 0 , 0 , 0 , NULL , { NULL , NULL }
	};

const TCB	____BEGIN_OFF_TCB_tinib = {
		{ NULL, NULL }, (TINIB *)1 , 0 , 0,
		0, 0 , 0 , 0 , NULL , { NULL , NULL }
	};

const TCB	____BEGIN_OFF_TCB_pc = {
		{ NULL, NULL }, NULL, 0, 0,
		0, 0 , 0 , 0 , NULL , { NULL , (FP)1 }
	};
const TCB	____BEGIN_OFF_TCB_sp = {
		{ NULL, NULL }, NULL, 0, 0,
		0, 0 , 0 , 0 , NULL , { (void *)1 , NULL }
	};

const TCB	____BEGIN_BIT_TCB_enatex = {
		{ NULL, NULL }, NULL, 0, 0,
		0, 0 , 1 , 0 , NULL , { NULL , NULL }
	};

const TCB	____BEGIN_OFF_TCB_texptn = {
		{ NULL, NULL }, NULL, 0, 0,
		0 , 0 , 0 , 1 , NULL , { NULL , NULL }
	};

const TINIB	____BEGIN_OFF_TINIB_exinf = {
		0 , (intptr_t)1 , NULL , 0 , 0 , NULL , 0 , NULL
	};

const TINIB	____BEGIN_OFF_TINIB_task = {
		0 , NULL , (TASK)1 , 0 , 0 , NULL , 0 , NULL
	};

