/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_agent.h 164 2016-03-07 11:33:50Z coas-nagasima $
 */

/*
 *		ECHONET Lite Im[h
 */

#ifndef ECHONET_NODE_H
#define ECHONET_NODE_H

#include "echonet.h"

#ifdef __cplusplus
extern "C" {
#endif

#define TNUM_AEOBJID 50

/*
 *  L[̃f[^\̒`
 */
typedef struct ecn_agent_queue {
#ifdef _DEBUG
	struct ecn_agent_queue *p_parent;	/* eL[ւ̃|C^ */
#endif
	struct ecn_agent_queue *p_next;		/* Ggւ̃|C^ */
	struct ecn_agent_queue *p_prev;		/* OGgւ̃|C^ */
} ecn_agent_queue_t;

#define PMAP_FLAG_SET	0x01
#define PMAP_FLAG_GET	0x02
#define PMAP_FLAG_ANNO	0x04

typedef struct ecn_obj
{
	ID eobjId;
	EOBJINIB inib;
	uint8_t pmapFlag;
	uint8_t pmapSet[16];		/* SETvpeB}bv */
	uint8_t pmapGet[16];		/* GETvpeB}bv */
	uint8_t pmapAnno[16];		/* ԕωʒmvpeB}bv */
	uint_t eprpcnt;				/* ECHONET Lite vpeB */
} ecn_obj_t;

typedef enum ecn_node_state
{
	ecn_node_state_idle,
	ecn_node_state_start,
	ecn_node_state_set_prpmap_wait,
	ecn_node_state_get_prpmap_wait,
	ecn_node_state_anno_prpmap_wait,
} ecn_node_state_t;

typedef struct ecn_node
{
	ecn_obj_t base;
	EOBJCB eobj;
	ECN_ENOD_ID enodId;
	ecn_agent_queue_t devices;
	ecn_node_state_t state;
	TMO timer;
	ecn_obj_t *current;
} ecn_node_t;

typedef struct ecn_device
{
	ecn_obj_t base;
	ecn_node_t *node;
} ecn_device_t;

typedef struct ecn_inm_get_device_list_req
{
	unsigned int requestid;
} ecn_inm_get_device_list_req_t;

typedef struct ecn_inm_get_device_item
{
	ID			eobjid;			/* ECHONET Lite IuWFNgID */
	ID			enodid;			/* ECHONET Lite m[hvt@CIuWFNgID */
	uint8_t		eojx1;			/* ECHONET Lite IuWFNg̃NXO[vR[h */
	uint8_t		eojx2;			/* ECHONET Lite IuWFNg̃NXR[h */
	uint8_t		eojx3;			/* ECHONET Lite IuWFNg̃CX^XR[h */
	ECN_ENOD_ID	addrid;			/* IPAhX擾pID */
} ecn_inm_get_device_item_t;

typedef struct ecn_inm_get_device_list_res
{
	unsigned int requestid;
	ecn_inm_get_device_item_t devices[1];
} ecn_inm_get_device_list_res_t;

typedef struct ecn_inm_get_device_info_req
{
	unsigned int requestid;
	ID eobjid;
} ecn_inm_get_device_info_req_t;

typedef struct ecn_inm_get_device_info_res
{
	unsigned int requestid;
	ID eobjid;
	uint8_t pmapSet[16];
	uint8_t pmapGet[16];
	uint8_t pmapAnno[16];
	uint_t eprpcnt;
} ecn_inm_get_device_info_res_t;

/*  */
void ecn_agent_init(void);
/* m[h */
ecn_node_t *ecn_agent_find_node(ECN_ENOD_ID enodid);
/* @ */
ecn_obj_t *ecn_agent_find_eobj(const EOBJCB *pk_nod, T_ECN_EOJ eoj);
/* IuWFNgID擾 */
ID ecn_agent_get_eobj(const EOBJINIB *pk_obj);
/* ̋@擾 */
const EOBJINIB *ecn_agent_next_eobj(const EOBJCB *pk_nod, const EOBJINIB *pk_obj);
/* IuWFNgIDEOJƃm[hID擾 */
bool_t ecn_agent_get_eoj_enodid(ID eobjid, T_ECN_EOJ *eoj, ECN_ENOD_ID *enodid);
/* ^CAEglԂ */
TMO ecn_agent_get_timer();
/* ^C}[̎Ԃi߂ */
void ecn_agent_progress(TMO interval);
/* ^CAEgî߂̌Ăяoj */
void ecn_agent_timeout();
/* bZ[W */
bool_t ecn_agent_proc_int_msg(ECN_FBS_ID fbs, uint8_t cmd);
/* ECHONETdM */
void ecn_agent_proc_ecn_msg(const EOBJCB **snod, const EOBJINIB **sobj, T_EDATA *esv);
/* ECHONETdMI */
void ecn_agent_proc_ecn_msg_end();
/* vpeB擾 */
const EPRPINIB *ecn_agent_get_property(const EOBJINIB *fp_obj, uint8_t fa_epc, const EPRPINIB *item);

ER ecn_agent_get_device_list(ID sender, int requestid, ECN_FBS_ID *pk_req);
ER ecn_agent_get_device_info(ID sender, int requestid, ID eobjid, ECN_FBS_ID *pk_req);

#ifdef __cplusplus
}
#endif

#endif /* ECHONET_NODE_H */
