/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014-2016 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_fbs.h 164 2016-03-07 11:33:50Z coas-nagasima $
 */

/*
 * Œ蒷obt@ϒXg[
 */

#ifndef TOPPERS_ECHONET_FBS_H
#define TOPPERS_ECHONET_FBS_H

#include <kernel.h>
#include "echonet.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ECHONET_MEMPOOL_GET_TMO
#define ECHONET_MEMPOOL_GET_TMO	(0)			/* v[擾̃^CAEgw */
#endif /* ECHONET_MEMPOOL_GET_TMO */

#ifndef NUM_ECHONET_MEMPOOL_BLOCK
#define NUM_ECHONET_MEMPOOL_BLOCK (60)		/* dpubN̐ */
#endif /* NUM_ECHONET_MEMPOOL_BLOCK */

#ifndef ECHONET_MEMPOOL_BLOCK_SIZE
#define ECHONET_MEMPOOL_BLOCK_SIZE (256)	/* dpubÑTCY */
#endif /* ECHONET_MEMPOOL_BLOCK_SIZE */

typedef unsigned int ECN_FBS_SIZE_T;	/* size_t  */
typedef int ECN_FBS_SSIZE_T;			/* ssize_t */

/* T_EDATAǗ̈TCY */
#ifdef TARGET_KERNEL_ASP
#define DEF_ECN_EDT_HDR_LEN (sizeof(T_MSG))
#else
#define DEF_ECN_EDT_HDR_LEN (sizeof(intptr_t))
#endif

/* Ǘ̈TCY(64byte - sizeof(T_MSG)) */
/* #define DEF_ECN_FBS_LIB_HDR_LEN ((ECHONET_MEMPOOL_BLOCK_SIZE + sizeof(int) - 1)>> 2) // */
#define DEF_ECN_FBS_LIB_HDR_LEN (64 - DEF_ECN_EDT_HDR_LEN)

/* Ǘ̈܂ރubNɕێf[^TCY */
#define DEF_ECN_FBS_FST_DAT_LEN (64)

/* N|C^z̃TCY(byte) */
#define DEF_ECN_FBS_LNK_LEN (ECHONET_MEMPOOL_BLOCK_SIZE - DEF_ECN_EDT_HDR_LEN - DEF_ECN_FBS_LIB_HDR_LEN - DEF_ECN_FBS_FST_DAT_LEN)

/* Œ蒷obt@őTCY */
#define DEF_ECN_FBS_BUF_MAXLEN ((DEF_ECN_FBS_LNK_LEN / sizeof(void *)) * ECHONET_MEMPOOL_BLOCK_SIZE + DEF_ECN_FBS_FST_DAT_LEN)

/* qvfobt@̃TCY */
#define DEF_ECN_FBS_SUB_BUF_LEN ECHONET_MEMPOOL_BLOCK_SIZE

/* d̎(e͉) */
typedef enum
{
	ECN_FBS_TYPE_BLANK		=	0,		/* gpXg[ */
	ECN_FBS_TYPE_INTERNAL	=	1,		/* bZ[W */
	ECN_FBS_TYPE_ECHONET	=	2		/* ECHONETd */
} TA_ECN_MSG_TYPE;

/* N|C^zɗ񋓂Aqvfobt@ */
typedef struct
{
	uint8_t	payload[ECHONET_MEMPOOL_BLOCK_SIZE];
} T_ECN_SUB_BLK;

/* N|C^z */
typedef union
{
	T_ECN_SUB_BLK	*p_sub[DEF_ECN_FBS_LNK_LEN / sizeof(T_ECN_SUB_BLK *)];
	uint8_t			bin[DEF_ECN_FBS_LNK_LEN];
} T_ECN_FBS_LNK;

/* Ǘ̈(64byte - sizeof(T_MSG)) */
typedef struct
{
	uint16_t	length;			/* bZ[W */
	uint16_t	type;			/* bZ[W^Cv */
	union{
		ECN_ENOD_ID id;			/* Mm[hIDiECHONETdj */
		ID mbxid;				/* M[{bNXIDibZ[Wj */
	}sender;
	union{
		ECN_ENOD_ID id;			/* Mm[hIDiECHONETdj */
		ID mbxid;				/* M惁[{bNXIDibZ[Wj */
	}target;
	union{
		ECN_ENOD_ID id;			/* ԐMm[hIDiECHONETdj */
		ID mbxid;				/* ԐM惁[{bNXIDibZ[Wj */
	}reply;

	int			rd;				/*	ǂݎwbh	*/
	int			wr;				/*	݃wbh	*/
} T_ECN_FBS_HDR;

/* Ǘ̈܂ރubN̍\ */
typedef struct
{
	uint8_t	_msg[DEF_ECN_EDT_HDR_LEN];	/* T_MSG */
	T_ECN_FBS_HDR	hdr;	/*	Ǘ̈  64byte  - sizeof(T_MSG)	*/
	uint8_t			_gap[DEF_ECN_FBS_LIB_HDR_LEN - sizeof(T_ECN_FBS_HDR)];
	T_ECN_FBS_LNK	lnk;	/*	N|C^z	128byte			*/
	uint8_t			payload[DEF_ECN_FBS_FST_DAT_LEN];
} T_ECN_FST_BLK;

/* FBS-ID */
typedef struct ecn_fbs_id_strc
{
	T_ECN_FST_BLK	*ptr;
} ECN_FBS_ID;

/* bZ[WL[ */
typedef struct ecn_fbs_queue
{
	T_ECN_FST_BLK	*pk_head;		/* 擪̃bZ[W */
	T_ECN_FST_BLK	*pk_last;		/* ̃bZ[W */
} T_ECN_FBS_QUEUE;

/*
 * ̈m
 *	
 *		ECN_FBS_SIZE_T	fa_req_size		vobt@TCY(byte)
 *										max: DEF_ECN_FBS_BUF_MAXLEN
 *		ECN_FBS_ID		*fp_id			mۂFBS-ID̊i[
 *	߂l
 *		ER				0:ok 0:NG
 */
ER _ecn_fbs_cre(ECN_FBS_SIZE_T fa_req_size, ECN_FBS_ID *fp_id);

/*
 * ̈
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *	߂l
 *		ER				0:ok, 0:NG
 */
ER _ecn_fbs_del(ECN_FBS_ID fa_id);

/*
 * ێf[^̗L
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *	߂l
 *		bool_t			0:, 1:
 */
bool_t _ecn_fbs_exist_data(ECN_FBS_ID fa_id);

/*
 * ێf[^̎擾
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *	߂l
 *		ECN_FBS_SSIZE_T	ێĂf[^̒(byte) -1:NG
 */
ECN_FBS_SSIZE_T _ecn_fbs_get_datalen(ECN_FBS_ID fa_id);

/*
 * ǂݎJ[\̈ʒu擾
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *	߂l
 *		ECN_FBS_SIZE_T	擪̐Έʒu -1:NG
 */
ECN_FBS_SSIZE_T _ecn_fbs_get_rpos(ECN_FBS_ID fa_id);

/*
 * ǂݎJ[\̈ʒuݒ
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *		ECN_FBS_SIZE_T	fa_pos	ݒ肷ʒu(擪̐Έʒu)
 *	߂l
 *		ER				0:ok, 0:NG
 */
ER _ecn_fbs_set_rpos(ECN_FBS_ID fa_id, ECN_FBS_SSIZE_T fa_pos);

/*
 * ǂݎJ[\̈ʒuړ
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *		ECN_FBS_SIZE_T	fa_seek	ړ(AOî)
 *	߂l
 *		ER				0:ok, 0:NG
 */
ER _ecn_fbs_seek_rpos(ECN_FBS_ID fa_id, ECN_FBS_SSIZE_T fa_seek);

/*
 * Cӎwʒu1byteǂݎ
 */
int _ecn_fbs_peek(ECN_FBS_ID fa_id, ECN_FBS_SSIZE_T fa_seek);

/*
 * Cӎwʒu1byte
 */
ER _ecn_fbs_poke(ECN_FBS_ID fa_id, ECN_FBS_SSIZE_T fa_seek, int fa_val);

/*
 * f[^ǉ
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *		const void *	fa_dat	ǉf[^
 *		ECN_FBS_SSIZE_T	fa_len	ǉ钷(byte)
 *	߂l
 *		ER				0:ok, 0:NG
 */
ER _ecn_fbs_add_data(ECN_FBS_ID fa_id, const void *fa_dat, ECN_FBS_SSIZE_T fa_len);

/*
 * f[^ǉ(̈IɊg)
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *		const void *	fa_dat	ǉf[^
 *		ECN_FBS_SSIZE_T	fa_len	ǉ钷(byte)
 *	߂l
 *		ER				0:ok, 0:NG
 */
ER _ecn_fbs_add_data_ex(ECN_FBS_ID fa_id, const void *fa_dat, ECN_FBS_SSIZE_T fa_len);

/*
 * f[^擾
 *	
 *		ecn_fbs_id^	mۂFBS-ID
 *		void *			fa_buf		擾obt@
 *		ECN_FBS_SSIZE_T	fa_maxlen	擾钷(byte)
 *		ECN_FBS_SSIZE_T	*p_len		擾(byte)
 *	߂l
 *		ER				0:ok, 0:NG
 */
ER _ecn_fbs_get_data(ECN_FBS_ID fa_id, void *fa_buf, ECN_FBS_SSIZE_T fa_maxlen,
	ECN_FBS_SSIZE_T *p_len);

ER ecn_fbs_enqueue(T_ECN_FBS_QUEUE *pk_queue, T_ECN_FST_BLK *pk_buf);
ER ecn_fbs_dequeue(T_ECN_FBS_QUEUE *pk_queue, T_ECN_FST_BLK **ppk_buf);

#ifdef __cplusplus
}   /* extern "C" */
#endif

#endif /* #ifndef TOPPERS_ECHONET_FBS_H */
